/*
 * Configuracion.java
 *
 * Created on 4 de marzo de 2006, 22:42
 */

package Flier_Match.FMCliente.sistema;
import java.awt.Color;
import java.awt.event.KeyEvent;
import java.util.StringTokenizer;

import javax.swing.JScrollPane;
import javax.swing.JTable;

import com.threed.jpct.FrameBuffer;
import com.threed.jpct.IRenderer;
import com.threed.jpct.VideoMode;
/**
 *
 * @author  Administrador
 */
public class Configuracion extends javax.swing.JFrame {
    private JTable tablaControl;
    private JScrollPane scrollControl;
    private Parametros P;
    private FrameBuffer buffer;
    private VideoMode vtemp [];
    
    private int x;
    private int y;
    private int idc;
    /** Creates new form Configuracion */
    public Configuracion() {
        idc=1;
        P=new Parametros ();
        P=P.cargar ();
        
        System.out.println (""+this.getClass().getResource("../../../Recursos"));
        
        initComponents();
        setSize (435, 530);
        setResizable(false);
        cargarTablaControl ();
        cargarOpcionesVideo ();
        cargarOpcionesJugador ();
        cargarOpcionesNet ();
    }
    
    private void cargarOpcionesJugador () {
        txt_jugadorNick.setText (P.getNickname ());
        if (P.getColor ()==1) lbl_jugadorEquipo.setText ("Rojo");
        if (P.getColor ()==2) lbl_jugadorEquipo.setText ("Azul");
        if (P.getColor ()==3) lbl_jugadorEquipo.setText ("Verde");
        if (P.getColor ()==4) lbl_jugadorEquipo.setText ("Blanco");
        if (P.getColor ()==5) lbl_jugadorEquipo.setText ("Amarillo");
        
    }
    
    private void cargarOpcionesNet () {
        txt_host.setText(P.host);
        txt_puerto.setText(P.puerto);
        
        System.out.println (P.host+": "+P.puerto);
        
    }
    
    private void cargarOpcionesVideo () {
        vtemp=buffer.getVideoModes (IRenderer.RENDERER_OPENGL);

        if (vtemp!=null) {
            cmb_jugadorRender.addItem ("Open Gl");
        }
        cmb_jugadorRender.addItem ("Software");
    }
    
    /**
     * Carga la JTable en donde se mostraran y configuraran los controles
     * del juego.
     */
    public void cargarTablaControl () {
        String Nombres []={"Comando:", "Predefinido:", "Actual:"};
        
        KeyEvent event=null;
        String Atributos [][]={
            {"Adelante:", "A", event.getKeyText (P.adelante)},
            {"Atras:", "Z", event.getKeyText (P.atras)},
            {"Girar izquierda:", "Izquierda", event.getKeyText (P.giroIzq)},
            {"Girar derecha:", "Derecha", event.getKeyText (P.giroDer)},
            {"Girar arriba:", "Abajo", event.getKeyText (P.giroArr)},
            {"Girar abajo:", "Arriba", event.getKeyText (P.giroAba)},
            {"Strafe:", "Mayusculas", event.getKeyText (P.strafe)},
            {"Estabilizar:", "Q", event.getKeyText (P.estabilizar)},
            {"Disparar balas:", "Ctrl", event.getKeyText (P.disparoBala)},
            {"Disparar misiles:", "Espacio", event.getKeyText (P.disparoMisil)},
            {"Iniciar chat:", "T", event.getKeyText (P.chat)}
        };
        tablaControl=new JTable (Atributos, Nombres);
        scrollControl=new JScrollPane (tablaControl);
        pnl_Control.add (scrollControl);
        scrollControl.setBounds (10, 130, 380, 197);
        
        tablaControl.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                tablaKeyPressed(evt);
            }
        });
        
        tablaControl.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                tablaMousePressed(evt);
            }
        });
 
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jTabbedPane1 = new javax.swing.JTabbedPane();
        pnl_Video = new javax.swing.JPanel();
        btn_videoAceptar = new javax.swing.JButton();
        cmb_jugadorRender = new javax.swing.JComboBox();
        jLabel4 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        cmb_jugadorResolucion = new javax.swing.JComboBox();
        jLabel2 = new javax.swing.JLabel();
        pnl_Jugador = new javax.swing.JPanel();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        btn_jugadorAceptar = new javax.swing.JButton();
        txt_jugadorNick = new javax.swing.JTextField();
        btn_jugadorBlanco = new javax.swing.JButton();
        btn_jugadorVerde = new javax.swing.JButton();
        btn_jugadorRojo = new javax.swing.JButton();
        btn_jugadorAzul = new javax.swing.JButton();
        btn_jugadorAmarillo = new javax.swing.JButton();
        lbl_jugadorEquipo = new javax.swing.JLabel();
        pnl_Control = new javax.swing.JPanel();
        btn_controlAceptar = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        pnl_network = new javax.swing.JPanel();
        lbl_imagenNET = new javax.swing.JLabel();
        lbl_puerto = new javax.swing.JLabel();
        txt_puerto = new javax.swing.JTextField();
        btn_netAceptar = new javax.swing.JButton();
        lbl_host = new javax.swing.JLabel();
        txt_host = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        
        getContentPane().setLayout(null);
        
        setTitle("Flier Match - Ventana de configuracion");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });
        
        jTabbedPane1.setBorder(new javax.swing.border.EtchedBorder());
        pnl_Video.setLayout(null);
        
        pnl_Video.setBackground(new java.awt.Color(90, 95, 168));
        btn_videoAceptar.setText("Aceptar");
        btn_videoAceptar.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                btn_videoAceptarMouseReleased(evt);
            }
        });
        
        pnl_Video.add(btn_videoAceptar);
        btn_videoAceptar.setBounds(300, 350, 79, 26);
        
        cmb_jugadorRender.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmb_jugadorRenderActionPerformed(evt);
            }
        });
        
        pnl_Video.add(cmb_jugadorRender);
        cmb_jugadorRender.setBounds(10, 350, 120, 25);
        
        jLabel4.setText("Tipo de render:");
        pnl_Video.add(jLabel4);
        jLabel4.setBounds(10, 330, 85, 16);
        
        jLabel3.setText("Resolucion:");
        pnl_Video.add(jLabel3);
        jLabel3.setBounds(150, 330, 66, 16);
        
        pnl_Video.add(cmb_jugadorResolucion);
        cmb_jugadorResolucion.setBounds(150, 350, 120, 25);
        
        jLabel2.setIcon(new javax.swing.ImageIcon(getClass().getResource("../../../Recursos/Imagenes/FMLOGO.jpg")));
        jLabel2.setBorder(new javax.swing.border.EtchedBorder());
        pnl_Video.add(jLabel2);
        jLabel2.setBounds(10, 10, 380, 310);
        
        jTabbedPane1.addTab("Video", pnl_Video);
        
        pnl_Jugador.setLayout(null);
        
        pnl_Jugador.setBackground(new java.awt.Color(159, 205, 99));
        jLabel8.setIcon(new javax.swing.ImageIcon(getClass().getResource("../../../Recursos/Imagenes/FMLOGO3.jpg")));
        jLabel8.setBorder(new javax.swing.border.EtchedBorder());
        pnl_Jugador.add(jLabel8);
        jLabel8.setBounds(10, 10, 380, 310);
        
        jLabel9.setText("Equipo:");
        pnl_Jugador.add(jLabel9);
        jLabel9.setBounds(10, 330, 41, 16);
        
        jLabel10.setText("Nickname:");
        pnl_Jugador.add(jLabel10);
        jLabel10.setBounds(140, 330, 60, 16);
        
        btn_jugadorAceptar.setText("Aceptar");
        btn_jugadorAceptar.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                btn_jugadorAceptarMouseReleased(evt);
            }
        });
        
        pnl_Jugador.add(btn_jugadorAceptar);
        btn_jugadorAceptar.setBounds(300, 350, 79, 26);
        
        pnl_Jugador.add(txt_jugadorNick);
        txt_jugadorNick.setBounds(140, 350, 130, 20);
        
        btn_jugadorBlanco.setBackground(new java.awt.Color(255, 254, 254));
        btn_jugadorBlanco.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                btn_jugadorBlancoMouseReleased(evt);
            }
        });
        
        pnl_Jugador.add(btn_jugadorBlanco);
        btn_jugadorBlanco.setBounds(70, 350, 20, 20);
        
        btn_jugadorVerde.setBackground(new java.awt.Color(46, 209, 42));
        btn_jugadorVerde.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                btn_jugadorVerdeMouseReleased(evt);
            }
        });
        
        pnl_Jugador.add(btn_jugadorVerde);
        btn_jugadorVerde.setBounds(50, 350, 20, 20);
        
        btn_jugadorRojo.setBackground(new java.awt.Color(246, 9, 9));
        btn_jugadorRojo.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                btn_jugadorRojoMouseReleased(evt);
            }
        });
        
        pnl_Jugador.add(btn_jugadorRojo);
        btn_jugadorRojo.setBounds(10, 350, 20, 20);
        
        btn_jugadorAzul.setBackground(new java.awt.Color(45, 62, 233));
        btn_jugadorAzul.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                btn_jugadorAzulMouseReleased(evt);
            }
        });
        
        pnl_Jugador.add(btn_jugadorAzul);
        btn_jugadorAzul.setBounds(30, 350, 20, 20);
        
        btn_jugadorAmarillo.setBackground(java.awt.Color.yellow);
        btn_jugadorAmarillo.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                btn_jugadorAmarilloMouseReleased(evt);
            }
        });
        
        pnl_Jugador.add(btn_jugadorAmarillo);
        btn_jugadorAmarillo.setBounds(90, 350, 20, 20);
        
        lbl_jugadorEquipo.setText(" ");
        pnl_Jugador.add(lbl_jugadorEquipo);
        lbl_jugadorEquipo.setBounds(60, 330, 50, 16);
        
        jTabbedPane1.addTab("Jugador", pnl_Jugador);
        //pnl_Jugador.setBackground(new Color (0, 0, 0));
        pnl_Control.setLayout(null);
        
        pnl_Control.setBackground(new java.awt.Color(226, 222, 146));
        btn_controlAceptar.setText("Aceptar");
        btn_controlAceptar.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                btn_controlAceptarMouseReleased(evt);
            }
        });
        
        pnl_Control.add(btn_controlAceptar);
        btn_controlAceptar.setBounds(300, 350, 79, 26);
        
        jLabel1.setIcon(new javax.swing.ImageIcon(getClass().getResource("../../../Recursos/Imagenes/FMLOGO4.jpg")));
        jLabel1.setBorder(new javax.swing.border.EtchedBorder());
        pnl_Control.add(jLabel1);
        jLabel1.setBounds(10, 10, 380, 110);
        
        jTabbedPane1.addTab("Control", pnl_Control);
        
        pnl_network.setLayout(null);
        
        pnl_network.setBackground(new java.awt.Color(179, 54, 179));
        pnl_network.setName("null");
        lbl_imagenNET.setBorder(new javax.swing.border.EtchedBorder());
        lbl_imagenNET.setIcon(new javax.swing.ImageIcon(getClass().getResource("../../../Recursos/Imagenes/FMLOGO3.jpg")));
        pnl_network.add(lbl_imagenNET);
        lbl_imagenNET.setBounds(10, 10, 380, 310);
        
        lbl_puerto.setText("Puerto:");
        pnl_network.add(lbl_puerto);
        lbl_puerto.setBounds(180, 330, 41, 16);
        
        pnl_network.add(txt_puerto);
        txt_puerto.setBounds(180, 350, 90, 20);
        
        btn_netAceptar.setText("Aceptar");
        pnl_network.add(btn_netAceptar);
        btn_netAceptar.setBounds(300, 350, 79, 26);
        btn_netAceptar.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                btn_netAceptarMouseReleased(evt);
            }
        });
        
        lbl_host.setText("Host:");
        pnl_network.add(lbl_host);
        lbl_host.setBounds(10, 330, 29, 16);
        
        pnl_network.add(txt_host);
        txt_host.setBounds(10, 350, 160, 20);
        
        jTabbedPane1.addTab("Network", pnl_network);
        
        getContentPane().add(jTabbedPane1);
        //jTabbedPane1.setBackground(new Color (0, 0, 0));
        jTabbedPane1.setBounds(10, 70, 410, 420);
        
        jLabel7.setFont(new java.awt.Font("Century Gothic", 1, 18));
        jLabel7.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        //jLabel7.setText("<====Flier Match=====>");
        jLabel7.setIcon(new javax.swing.ImageIcon(getClass().getResource("../../../Recursos/Imagenes/Banner.jpg")));
        jLabel7.setBorder(new javax.swing.border.EtchedBorder());
        getContentPane().add(jLabel7);
        jLabel7.setBounds(10, 10, 410, 60);
        
        pack();
    }//GEN-END:initComponents

    private void cmb_jugadorRenderActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmb_jugadorRenderActionPerformed
        // Add your handling code here:
        
    	String opcion=""+cmb_jugadorRender.getSelectedItem();
        
        int res []=P.getResolucion();
        
        cmb_jugadorResolucion.removeAllItems();
        if (opcion.compareTo ("Software")==0) {
            P.setRender(1);
            cmb_jugadorResolucion.addItem ("1152x864");
            cmb_jugadorResolucion.addItem ("1088x612");
            cmb_jugadorResolucion.addItem ("1024x768");
            cmb_jugadorResolucion.addItem ("960x600");
            cmb_jugadorResolucion.addItem ("800x600");
            cmb_jugadorResolucion.addItem ("640x480");
        }
        
        if (opcion.compareTo ("Open Gl")==0) {
            P.setRender(2);
            for (int i=0;i<vtemp.length;i++) {
                //if (vtemp [i].width==640 && vtemp [i].height==480 && vtemp [i].bpp==32 && vtemp [i].refresh==60) cmb_jugadorResolucion.addItem ("640x480");
                //if (vtemp [i].width==800 && vtemp [i].height==600 && vtemp [i].bpp==32 && vtemp [i].refresh==60) cmb_jugadorResolucion.addItem ("800x600");
                //if (vtemp [i].width==1024 && vtemp [i].height==768 && vtemp [i].bpp==32 && vtemp [i].refresh==60) cmb_jugadorResolucion.addItem ("1024x768");
                //if (vtemp [i].width==1152 && vtemp [i].height==864 && vtemp [i].bpp==32 && vtemp [i].refresh==60) cmb_jugadorResolucion.addItem ("1152x864");
                int ancho=vtemp [i].width;
                int alto=vtemp [i].height;
            	if (vtemp [i].bpp==32 && vtemp [i].refresh==60) {
            		cmb_jugadorResolucion.addItem (ancho+"x"+alto);          		
            	}
            }
        }
        cmb_jugadorResolucion.setSelectedItem((res [0]+"x"+res [1]));
    }//GEN-LAST:event_cmb_jugadorRenderActionPerformed

        
    private void tablaKeyPressed (java.awt.event.KeyEvent evt) {
        if (evt.getKeyCode ()==evt.VK_DOWN) tablaControl.setValueAt ("Abajo", x, y);
        
        else {
            tablaControl.setValueAt (evt.getKeyText (evt.getKeyCode ()), x, y);
            String temp=tablaControl.getValueAt (x, y).toString ();
            if (temp.length()<=1) tablaControl.setValueAt ("", x, y);
            tablaControl.transferFocus();
        }
        
        switch (x) {
            case 0: {
                P.adelante=evt.getKeyCode ();
                break;
            }
            case 1: {
                P.atras=evt.getKeyCode ();
                break;
            }
            case 2: {
                P.giroIzq=evt.getKeyCode ();
                break;
            }
            case 3: {
                P.giroDer=evt.getKeyCode ();
                break;
            }
            case 4: {
                P.giroArr=evt.getKeyCode ();
                break;
            }
            case 5: {
                P.giroAba=evt.getKeyCode ();
                break;
            }
            case 6: {
                P.strafe=evt.getKeyCode ();
                break;
            }
            case 7: {
                P.estabilizar=evt.getKeyCode ();
                break;
            }
            case 8: {
                P.disparoBala=evt.getKeyCode ();
                break;
            }
            case 9: {
                P.disparoMisil=evt.getKeyCode ();
                break;
            }
            case 10: {
                P.chat=evt.getKeyCode ();
                break;
            }
        };
        
    }
    
    private void tablaMousePressed (java.awt.event.MouseEvent evt) {
        
        x=0;
        y=0;
        x=tablaControl.getSelectedRow();
        y=tablaControl.getSelectedColumn();
        if (y==2) {
            tablaControl.setValueAt ("", x, y);
        }
    }
    
    private void btn_jugadorAmarilloMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btn_jugadorAmarilloMouseReleased
        // Add your handling code here:
        lbl_jugadorEquipo.setText ("Amarillo");
        idc=5;
    }//GEN-LAST:event_btn_jugadorAmarilloMouseReleased

    private void btn_jugadorBlancoMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btn_jugadorBlancoMouseReleased
        // Add your handling code here:
        lbl_jugadorEquipo.setText ("Blanco");
        idc=4;
    }//GEN-LAST:event_btn_jugadorBlancoMouseReleased

    private void btn_jugadorVerdeMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btn_jugadorVerdeMouseReleased
        // Add your handling code here:
        lbl_jugadorEquipo.setText ("Verde");
        idc=3;
    }//GEN-LAST:event_btn_jugadorVerdeMouseReleased

    private void btn_jugadorAzulMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btn_jugadorAzulMouseReleased
        // Add your handling code here:
        lbl_jugadorEquipo.setText ("Azul");
        idc=2;
    }//GEN-LAST:event_btn_jugadorAzulMouseReleased

    private void btn_jugadorRojoMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btn_jugadorRojoMouseReleased
        // Add your handling code here:
        lbl_jugadorEquipo.setText ("Rojo");
        idc=1;
    }//GEN-LAST:event_btn_jugadorRojoMouseReleased

    private void btn_controlAceptarMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btn_controlAceptarMouseReleased
        // Add your handling code here:
        aceptar ();
    }//GEN-LAST:event_btn_controlAceptarMouseReleased

    private void btn_jugadorAceptarMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btn_jugadorAceptarMouseReleased
        // Add your handling code here:
        aceptar ();
    }//GEN-LAST:event_btn_jugadorAceptarMouseReleased

    private void btn_videoAceptarMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btn_videoAceptarMouseReleased
        // Add your handling code here:
        aceptar ();
    }//GEN-LAST:event_btn_videoAceptarMouseReleased

    private void btn_netAceptarMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btn_videoAceptarMouseReleased
        // Add your handling code here:
        aceptar ();
    }
    
    
    /**
     * Acepta los cambios realizados en la configuracion, guarda los
     * nuevos parametros e inicia el juego.
     */
    private void aceptar () {
        P.setColor (idc);
        
        if (txt_jugadorNick.getText ().compareTo ("")==0) P.setNickname ("Jugador");
        else P.setNickname (txt_jugadorNick.getText ());
        StringTokenizer separador=new StringTokenizer (""+cmb_jugadorResolucion.getSelectedItem (), "x");
        P.setResolucion (Integer.parseInt (separador.nextToken()), Integer.parseInt (separador.nextToken()));
        
        P.host=txt_host.getText();
        P.puerto=txt_puerto.getText();
        
        P.guardar ();
        
        //salir
        Confirmacion C=new Confirmacion (this, false);
        C.setBounds (100, 100, 280, 300);
        C.show ();

        btn_jugadorAceptar.setEnabled (false);
        btn_videoAceptar.setEnabled (false);
        btn_controlAceptar.setEnabled (false);
        btn_netAceptar.setEnabled(false);
    }
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        new Configuracion().show();
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JPanel pnl_Video;
    private javax.swing.JButton btn_videoAceptar;
    private javax.swing.JComboBox cmb_jugadorRender;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JComboBox cmb_jugadorResolucion;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel pnl_Jugador;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JButton btn_jugadorAceptar;
    private javax.swing.JTextField txt_jugadorNick;
    private javax.swing.JButton btn_jugadorBlanco;
    private javax.swing.JButton btn_jugadorVerde;
    private javax.swing.JButton btn_jugadorRojo;
    private javax.swing.JButton btn_jugadorAzul;
    private javax.swing.JButton btn_jugadorAmarillo;
    private javax.swing.JLabel lbl_jugadorEquipo;
    private javax.swing.JPanel pnl_Control;
    private javax.swing.JButton btn_controlAceptar;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JPanel pnl_network;
    private javax.swing.JLabel lbl_imagenNET;
    private javax.swing.JLabel lbl_puerto;
    private javax.swing.JTextField txt_puerto;
    private javax.swing.JButton btn_netAceptar;
    private javax.swing.JLabel lbl_host;
    private javax.swing.JTextField txt_host;
    // End of variables declaration//GEN-END:variables

}
